#include <stdio.h>
#include "iodefine.h"
#include "ivects.h"
#include "tty.h"
#include "cprintf.h"
#include "sram.h"

main()
{
  int i, j;
  volatile unsigned char *ram_base;
  volatile unsigned short *ram_short;
  volatile unsigned long *ram_long;
  unsigned long ram_size;
  SYSTEM.SCKCR.LONG = 0x00010100;

  tty_init ();
  tty_puts("\nHello, world\n");

  PORT4.DR.BYTE = 0;
  PORT4.DDR.BIT.B2 = 1;
  PORT4.DDR.BIT.B3 = 1;
  PORT4.DDR.BIT.B4 = 1;
  PORT4.DDR.BIT.B5 = 1;
  PORT4.DDR.BIT.B6 = 1;
  PORT4.DDR.BIT.B7 = 1;

  PORT9.DR.BYTE = 0;
  PORT9.DDR.BIT.B0 = 1;
  PORT9.DDR.BIT.B1 = 1;
  PORT9.DDR.BIT.B2 = 1;
  PORT9.DDR.BIT.B3 = 1;

  PORT2.DR.BYTE = 0;
  PORT2.DDR.BIT.B1 = 1;
  PORT2.DDR.BIT.B2 = 1;
  PORT2.DDR.BIT.B3 = 1;
  PORT2.DDR.BIT.B4 = 1;
  PORT2.DDR.BIT.B5 = 1;

  sram_init ();
  ram_base = sram_base ();
  cprintf("sram base %l\n", ram_base);
  ram_size = sram_size ();
  cprintf("sram size %l\n", ram_size);

  for (i=0; i<16; i++)
    ram_base[i] = i;
  for (i=0; i<16; i++)
    cprintf(" %b", ram_base[i]);
  cprintf("\n");

  ram_short = (volatile unsigned short *)(ram_base);
  for (i=0; i<16; i++)
    {
      ram_short[0] = 1 << i;
      ram_short[1] = ~ (1 << i);
      cprintf("%b : %B%B %B%B\n", i, ram_base[1], ram_base[0], ram_base[3], ram_base[2]);
    }

  for (i=20; i>=2; i--)
    {
      ram_long = (volatile unsigned long *)(ram_base + (1<<i));
      for (j=0; j<8 && j < (1<<(i-2)); j++)
	ram_long[j] = (1 << i) | (j << 28);
    }
  for (i=0; i<4; i++)
    ram_base[i] = 0x11;
  for (i=20; i>=2; i--)
    {
      ram_long = (volatile unsigned long *)(ram_base + (1<<i));
      cprintf("%d%d: %l:", i/10, i%10, ram_long);
      for (j=0; j<8; j++)
	cprintf(" %l", ram_long[j]);
      cprintf("\n");
    }
  

  tty_puts ("\nRunning LED diagnostics...\n");
  tty_putc (3);
  tty_putc (3);
  tty_putc (0);
  while (1)
    {
      PORT4.DR.BYTE = 0;
      switch (i & 3)
	{
	case 0:
	  PORT9.DR.BYTE = 1;
	  break;
	case 1:
	  PORT9.DR.BYTE = 2;
	  break;
	case 2:
	  PORT9.DR.BYTE = 4;
	  break;
	case 3:
	  PORT9.DR.BYTE = 8;
	  break;
	}
      PORT4.DR.BYTE = 4 << (i >> 2);
      PORT2.DR.BYTE = 2 << (i >> 2);
      i ++;
      if (i >= 24)
	i = 0;
      for (j=0; j<3000000; j++)
	asm("");
    }

}
