extern float fadd( float a, float b );

#ifdef FADD_FUNC
float fadd( float a, float b )
{
  return (a + b);
}
#else /*FADD_FUNC*/

#include <stdio.h>

typedef union {
  unsigned long v_ul;
  float         v_float;
} Float;

Float u_a, u_b, u_c, u_d, u_e;

#define FLOAT_BIT_PATTERN( s, e, m ) \
 ( (( (s)      & 1)<< 31) \
  |((((e)+ 128)& 255)<< 23)\
  |(  (m)      & 0x007fffff) )

int check(Float x, Float exp)
{
  Float r;

  r.v_float = x.v_float - exp.v_float;

  if (r.v_ul)
    printf("NG\n");
  else
    printf("OK\n");

  return (int)r.v_ul;
}

int main(void)
{
  int stat = -1;

  u_a.v_ul = FLOAT_BIT_PATTERN( 0, 24, 0x00f7ffff );
  u_b.v_ul = FLOAT_BIT_PATTERN( 0, 20,  0x0080000f );
  u_c.v_ul = FLOAT_BIT_PATTERN( 0, 25, 0x00800000 );
  printf("u_c.f_float = %g (expected value)\n", u_c.v_float);

  u_d.v_float = u_a.v_float + u_b.v_float;
  printf("u_d.f_float = %g : ", u_d.v_float);
  stat = check(u_d, u_c);

  u_e.v_float = fadd( u_a.v_float, u_b.v_float );
  printf("u_e.f_float = %g : ", u_e.v_float);
  stat |= check(u_e, u_c);

  return stat;
}
#endif /*FADD_FUNC*/
